/* DictFix internal component - Copyright (C) 2007 Rod Whiteley - Licensed under the Open Software License version 3.0 - Source at http://journal.mozdev.org/dictfix.html */
function NSGetModule(compMgr, fileSpec) {
return dictfixModule}
var dictfixModule = {
CID: Components.ID("{a50138e3-6182-50b4-758d-5d92cd916111}"),contractID: "@rod.whiteley/dictfix;1",className: "DictFix",registerSelf: function (mgr, file, loc, type) {
mgr.QueryInterface(Components.interfaces.nsIComponentRegistrar).registerFactoryLocation(this.CID, this.className, this.contractID, file, loc, type)
Components.classes["@mozilla.org/categorymanager;1"].getService(Components.interfaces.nsICategoryManager).addCategoryEntry("app-startup", this.className, "service," + this.contractID, true, true, null)},getClassObject: function (aComponentManager, aCID, aIID) {
if (!aIID.equals(Components.interfaces.nsIFactory))
throw Components.results.NS_ERROR_NOT_IMPLEMENTED
if (!aCID.equals(this.CID))
throw Components.results.NS_ERROR_NO_INTERFACE
return this.factory},factory: {
createInstance: function (aOuter, aIID) {
if (aOuter != null) throw Components.results.NS_ERROR_NO_AGGREGATION
return DictFix}},canUnload: function () {return true}}
DictFix = {
app: Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("AChrom", Components.interfaces.nsIFile).parent,bundles: Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService),obs: Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService),pref: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService),spell: Components.classes["@mozilla.org/spellchecker/myspell;1"].getService(Components.interfaces.mozISpellCheckingEngine),_cleanup: [],_info: {},_status: [],_statustype: 0,init: function () {
var b = this.bundles.createBundle("chrome://dictfix/locale/dictfix.properties").getSimpleEnumeration()
while (b.hasMoreElements()) {
var e = b.getNext().QueryInterface(Components.interfaces.nsIPropertyElement)
this._info[e.key] = e.value}
this._info.delete = ""
this._language = this.bundles.createBundle("chrome://global/locale/languageNames.properties")
this._region = this.bundles.createBundle("chrome://global/locale/regionNames.properties")},observe: function (subject, topic, data) {
switch (topic) {
case "app-startup":
this.obs.addObserver(this, "domwindowopened", false)
this.obs.addObserver(this, "em-action-requested", false)
try {this.init()} catch (ex) {this.report("error", ex.lineNumber)}
try {this.setDir()} catch (ex) {this.report("error", ex.lineNumber)}
break;
case "domwindowopened":
try {this.setLang()} catch (ex) {this.report("error", ex.lineNumber)}
var self = this
var focus = function (event) {
event.target.removeEventListener("focus", focus, false)
self.prompt(subject, event)}
subject.addEventListener("load",function (event) {
var tt = event.target.getElementById("threadTree")
if (!tt) return
self.obs.removeObserver(self, "domwindowopened", false)
tt.addEventListener("focus", focus, false)},false)
break;
case "em-action-requested":
var item = subject.QueryInterface(Components.interfaces.nsIUpdateItem)
if (item.id != "dictionary-fix@rod.whiteley") return
switch (data) {
case "item-disabled":
case "item-uninstalled":
with (this.pref.getBranch("extension.dictfix.")) {
this._pref_clear = getBoolPref("clear")
this._pref_version = getCharPref("version")
deleteBranch("")}
break;
case "item-cancel-action":
with (this.pref.getBranch("extension.dictfix."))
setBoolPref("clear", this._pref_clear),setCharPref("version", this._pref_version)
break;}
break;}},prompt: function (wdw, evt) {
var cp = this.pref.getBranch("extension.dictfix.")
var v0 = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager).getItemForID("dictionary-fix@rod.whiteley").version
this._about = (cp.getCharPref("version") != v0)
if (this._about) cp.setCharPref("version", v0)
var clear = !this._status || !this._status[0]
var wasclear = cp.getBoolPref("clear")
if (clear && wasclear && !this._about) return
if (clear) this.report("clear", "")
cp.setBoolPref("clear", clear)
wdw.openDialog(
"chrome://dictfix/content/alert.xul","_blank","chrome,modal,centerscreen",this)
this._status = null},realName: function (abbr) {
var part = abbr.split("-"), fail = 0
if (part[0]) {
try {part[0] = this._language.GetStringFromName(part[0].toLowerCase())}
catch (ex) {++fail}}
if (part[1]) {
try {part[1] = this._region.GetStringFromName(part[1].toLowerCase())}
catch (ex) {++fail}}
if (fail == 2) return abbr
else return part[0] + (part[1]? "/" + part[1] : "") + (part[2]? " (" + part[2] + ")" : "")},report: function (n, text) {
if (n == "old" || n == "new" || n == "current") text = this.realName(text)
if (n == "error" || n == "dir") text = text > 999? "00" : text.toString(16).toUpperCase()
this._status.push(this._info[n].replace(/%S/, text))
var t = n == "error" || n =="dir"? 2 : n == "none" || n == "zip"? 1 : 0
if (this._statustype < t) this._statustype = t
if (n == "zip") {
this._info.delete = this._info.delete? this._info.deleteN : this._info.delete1
this._cleanup.push(text)}},setDir: function () {
var dd = this.app.clone()
dd.append("dictionaries")
if (!dd.exists()) {
try {dd.create(1, 0755), this.report("missing", "")}
catch (ex) {
this.report("dir", "")
return}}
if (!dd.isDirectory()) {
try {dd.remove(false), dd.create(1, 0755), this.report("missing", "")}
catch (ex) {
this.report("dir", "")
return}}
var cm = this.app.clone()
cm.append("components")
cm.append("myspell")
if (cm.exists()) {
var cfs = cm.directoryEntries
while (cfs.hasMoreElements()) {
var cf = cfs.getNext().QueryInterface(Components.interfaces.nsIFile)
var df = dd.clone()
df.append(cf.leafName)
if (!df.exists()) {
var nn = cf.leafName.replace(/_/, "-")
cf.moveTo(dd, nn)
if (/\.dic$/.test(cf.leafName))
this.report("old", nn.replace(/\.dic$/, ""))}}}
var des = dd.directoryEntries
while (des.hasMoreElements()) {
var de = des.getNext().QueryInterface(Components.interfaces.nsIFile)
if (/\.xpi$|\.zip$/.test(de.leafName))
try {this.unzip(de)} catch (ex) {this.report("zip", de.leafName)}}},setLang: function () {
if (this._statustype == 2) return
var cc = this.pref.getBranch("extensions.")
var val = true
try {val = cc.getBoolPref("checkCompatibility")} catch (ex) {}
if (val) {
cc.setBoolPref("checkCompatibility", false)
val = cc.getBoolPref("checkCompatibility")
this.report("addon")}
var temp = {}
this.spell.getDictionaryList(temp, {})
this._dics = temp.value
var sd = this.pref.getBranch("spellchecker.")
var loc = sd.getCharPref("dictionary")
if (this.validate(loc)) return
loc = this.pref.getBranch("general.useragent.").getCharPref("locale")
if (!this.validate(loc)) loc = this._dics[0]
if (loc) {
sd.setCharPref("dictionary", loc)
this.report("current", loc)}
else this.report("none")},unzip: function (zip) {
var dd = this.app.clone()
dd.append("dictionaries")
var zr = Components.classes["@mozilla.org/libjar/zip-reader;1"].createInstance(Components.interfaces.nsIZipReader)
zr.init(zip)
zr.open()
var zes = zr.findEntries("*.dic")
if (!zes.hasMoreElements()) return
while (zes.hasMoreElements()) {
var ze = zes.getNext().QueryInterface(Components.interfaces.nsIZipEntry)
var df = dd.clone()
var nn = ze.name.replace(/^.*[\/\\]/, "").replace(/_/, "-")
df.append(nn)
zr.extract(ze.name, df)
this.report("new", nn.replace(/\.dic$/, ""))}
var zes = zr.findEntries("*.aff")
while (zes.hasMoreElements()) {
var ze = zes.getNext().QueryInterface(Components.interfaces.nsIZipEntry)
var df = dd.clone()
var nn = ze.name.replace(/^.*[\/\\]/, "").replace(/_/, "-")
df.append(nn)
zr.extract(ze.name, df)}
var zes = zr.findEntries("README*")
while (zes.hasMoreElements()) {
var ze = zes.getNext().QueryInterface(Components.interfaces.nsIZipEntry)
var df = dd.clone()
df.append(ze.name)
zr.extract(ze.name, df)}
zr.close()
try {zip.remove(false)} catch (ex) {}},toString: function () {
return "[object DictFix]"},validate: function (loc) {
if (!loc) return false
for each (var dic in this._dics) if (dic.indexOf(loc) == 0) return true
return false},zipCleanup: function () {
var dd = this.app.clone()
dd.append("dictionaries")
for each (var zip in this._cleanup) {
var f = dd.clone()
f.append(zip)
try {f.remove(false)} catch (ex) {}}}}
